<?php
namespace Teknisa\OPL\Modules\OperadorLogistico\Services;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class Dfs72000EntradaDevolucoesDoOperadorLogisticoService {
    
    protected $connection;
    protected $newCode;
    
    const PROCEDURE_GERA_NOTA_CORPO_ENTRADA = 'GERA_NOTAFISCAL_CORPO_ENTRADA';
    const PROCEDURE_GERA_PRODUTO    = 'GERA_NOTAFISCAL_PRODUTO';
    const PROCEDURE_IMPOSTO_ENTRADA_PRODUTO    = 'IMPOSTO_ENTRADA_PRODUTO';
    const PROCEDURE_GERA_FECHAMENTO_ENTRADA = 'GERA_FECHAMENTO_NFENTRADA';
    
    
    
    
    
    public function geraCorpoNotaEntrada($cdfilial, $cdfilirece, $cdempresa, $cdtipooper, $cdserieentr, $cdcliente, $sistema, $atualizaestoque, 
        $nrlanctonf, $pesstrans, $insctrans, $placaveiculo, $ufveiculo, $pgtofrete, $quantidadedevolu, $espefvolu, $marcvolu, $numevolu, $nrlancestoq,
        $dtentrsaid, $vrbrutovolu, $vrliquidovolu, $vrnotafisc, $nrlancorig, $dtlancmennf, $dtemissao, $nrnotafisc, $nracessonfe, $cdmododocfisc) {
        
        $dtemissao  = str_replace("-", "/", $dtemissao);
        $dtentrsaid = str_replace("-", "/", $dtentrsaid);
        
        $prxLanctoNf    = NULL;
        $prxLanctoEstoq = NULL;
        
        $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_GERA_NOTA_CORPO_ENTRADA);
        $procedure->addParam(new Param('P_CDFILIAL',        Param::PARAM_INPUT, $cdfilial,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIRECE',      Param::PARAM_INPUT, $cdfilirece,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDEMPRESA',       Param::PARAM_INPUT, $cdempresa,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDTIPOOPER',      Param::PARAM_INPUT, $cdtipooper,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSERIEENTR',     Param::PARAM_INPUT, $cdserieentr,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCLIENTE',       Param::PARAM_INPUT, $cdcliente,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTENTRSAID',      Param::PARAM_INPUT, $dtentrsaid,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDSISTEMA',       Param::PARAM_INPUT, $sistema,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRNOTAFISC',      Param::PARAM_INPUT, $vrnotafisc,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_PRXLANCTONF',     Param::PARAM_OUTPUT,$prxLanctoNf,       Param::PARAM_TYPE_STR, 10));
        $procedure->addParam(new Param('P_PRXLANCESTQ',     Param::PARAM_OUTPUT,$prxLanctoEstoq,    Param::PARAM_TYPE_STR, 10));
        $procedure->addParam(new Param('P_ATUAESTOQUE',     Param::PARAM_INPUT, $atualizaestoque,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRAPURACFAT',     Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCTONF',      Param::PARAM_INPUT, $nrlanctonf,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDTPIJURTRAN',    Param::PARAM_INPUT, $pesstrans,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRINSJURTRAN',    Param::PARAM_INPUT, $insctrans,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRPLACAVEIC',     Param::PARAM_INPUT, $placaveiculo,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_SGUFVEIC',        Param::PARAM_INPUT, $ufveiculo,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDPGTOFRETE',     Param::PARAM_INPUT, $pgtofrete,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DSQTDEVOLU',      Param::PARAM_INPUT, $quantidadedevolu,  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DSESPECVOLU',     Param::PARAM_INPUT, $espefvolu,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DSMARCAVOLU',     Param::PARAM_INPUT, $marcvolu,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DSNUMEVOLU',      Param::PARAM_INPUT, $numevolu,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRPBRUTOVOLU',    Param::PARAM_INPUT, $vrbrutovolu,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRPLIQUVOLU',     Param::PARAM_INPUT, $vrliquidovolu,     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCESTQ',      Param::PARAM_INPUT, $nrlancestoq,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCORIG',      Param::PARAM_INPUT, $nrlancorig,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTLANCAMENNF',    Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRNOTAFISC',      Param::PARAM_INPUT, $nrnotafisc,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTEMISSAO',       Param::PARAM_INPUT, $dtemissao,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRACESSONFE',     Param::PARAM_INPUT, $nracessonfe,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDMODDOCFISC',    Param::PARAM_INPUT, $cdmododocfisc,     Param::PARAM_TYPE_STR));
        
        return $procedure->execute();
        
    }
    
    public function procedureGeraNotaFiscalProduto($filial, $numLancamento, $produto, $codEmissao, $descEmissao, $quantidade, $vrUnitario, $vrDesconto,
        $almoxarifado = null, $localEstoque = null, $nrloteestq = null, $nrsublote = null, $cdservfatu = null,
        $idOrigemProd = null, $idAtuEstProd = 'S',  $vrICMSItOrig = null, $cdMarca = null) {
            
        $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_GERA_PRODUTO);
        $procedure->addParam(new Param('P_CDFILIAL',        Param::PARAM_INPUT, $filial,            Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCTONF',      Param::PARAM_INPUT, $numLancamento,     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODUTO',       Param::PARAM_INPUT, $produto,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPRODEMIS',      Param::PARAM_INPUT, $codEmissao,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DSPRODEMIS',      Param::PARAM_INPUT, $descEmissao,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_QTITEMPROD',      Param::PARAM_INPUT, $quantidade,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRUNITITEM',      Param::PARAM_INPUT, $vrUnitario,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRDESCITEM',      Param::PARAM_INPUT, $vrDesconto,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIALPED',     Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRPEDIDO',        Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRITEMPED',       Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCSTINFUSU',     Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCFOPINFUSU',    Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSUFXINFUSU',    Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDALMOXARIFE',    Param::PARAM_INPUT, $almoxarifado,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDLOCALESTOQ',    Param::PARAM_INPUT, $localEstoque,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLOTEESTQ',      Param::PARAM_INPUT, $nrloteestq,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRSUBLOTE',       Param::PARAM_INPUT, $nrsublote,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDCONFORITEM',    Param::PARAM_INPUT, 'S',                Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDTPNFCREDEB',    Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_QTVOLUITEM',      Param::PARAM_INPUT, 0,                  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSERVFILI',      Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIAPUR',      Param::PARAM_INPUT, NULL,               Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDMARCA',         Param::PARAM_INPUT, $cdMarca,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSERVFATU',      Param::PARAM_INPUT, $cdservfatu,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDORIGEMPROD',    Param::PARAM_INPUT, $idOrigemProd,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDATUESTPROD',    Param::PARAM_INPUT, $idAtuEstProd,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRICMSSTITORIG',  Param::PARAM_INPUT, $vrICMSItOrig,      Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
    
    
    
    private function procedureGeraFechamentoEntrada($filial, $numLancamento, $dtProcessamento, $numLancEstoque, $operador = '')
    {
        $connection = $this->entityManager->getConnection();
        $connection->beginTransaction();
        $organizacao = $this->environment->getNrOrgTrab();
        $notaFiscal = Notafiscal::findOneByCdfilialAndNrlanctonfAndNrorg($filial, $numLancamento, $organizacao);
        $this->entityManager->refresh($notaFiscal);
        $notaFiscal->setIdstatus('P');
        $notaFiscal->persist();
        $this->entityManager->flush();
        $connection->commit();
            
        $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_GERA_FECHAMENTO_ENTRADA);
        $procedure->addParam(new Param('P_CDFILIAL',        Param::PARAM_INPUT, $filial,            Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCTONF',      Param::PARAM_INPUT, $numLancamento,     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAPROC',        Param::PARAM_INPUT, $dtProcessamento,   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLANCESTQ',      Param::PARAM_INPUT, $numLancEstoque,    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR',      Param::PARAM_INPUT, $operador,          Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
    
    private function callProcedureImpostoEntrada($empresa, $inscesta, $tipoOperacao, $fornecedor, $filial,
        $seqLancamento, $dtEntrada, $entrada_saida, $operador, $grupofiscal,
        $idinterest, $cdarvprod, $cdgrpfiscsv, $idorigdestnf, $filialRece, $cdfiliemit,
        $cliente, $valorProduto) {
            
        $procedure = new StoredProcedure($this->entityManager->getConnection(), self::PROCEDURE_IMPOSTO_ENTRADA_PRODUTO);
        $procedure->addParam(new Param('P_EMPRESA',         Param::PARAM_INPUT, $empresa,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_INSCESTA',        Param::PARAM_INPUT, $inscesta,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_TIPOOPER',        Param::PARAM_INPUT, $tipoOperacao,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFORNECED',      Param::PARAM_INPUT, $fornecedor,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_FILIAL',          Param::PARAM_INPUT, $filial,            Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_LANCTONF',        Param::PARAM_INPUT, $seqLancamento,     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_INIVALID',        Param::PARAM_INPUT, $dtEntrada,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_ENTRSAID',        Param::PARAM_INPUT, $entrada_saida,     Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR',      Param::PARAM_INPUT, $operador,          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDGRUPOFISC',     Param::PARAM_INPUT, $grupofiscal,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDINTEREST',      Param::PARAM_INPUT, $idinterest,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDARVPROD',       Param::PARAM_INPUT, $cdarvprod,         Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDGRPFISCSV',     Param::PARAM_INPUT, $cdgrpfiscsv,       Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDORIGDESTNF',    Param::PARAM_INPUT, $idorigdestnf,      Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIRECE',      Param::PARAM_INPUT, $filialRece,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDFILIEMIT',      Param::PARAM_INPUT, $cdfiliemit,        Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCLIENTE',       Param::PARAM_INPUT, $cliente,           Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_VRPRODUTO',       Param::PARAM_INPUT, $valorProduto,      Param::PARAM_TYPE_STR));
        
        $procedure->execute();
    }
}